#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cstdarg>
#include <cctype>
#include <strstream>
#include <string>
#include <map>
#include <set>
using namespace std;

#define IN argv[1]
#define OUT argv[3]
#define HINT argv[2]
#define MAXLINE 300

void ERR(const char *s, ...) {
    fprintf(stderr, "Error: ");
    va_list ap;
    va_start(ap, s);
    vfprintf(stderr, s, ap);
    va_end(ap);
    fprintf(stderr, "\n");
	fprintf(stdout, "%d\n", 0);
    exit(0);
}

void OK(int n, const char *s, ...) {
    va_list ap;
    va_start(ap, s);
    vfprintf(stderr, s, ap);
    va_end(ap);
    fprintf(stderr, "\n");
	fprintf(stdout, "%lf\n", n/100.0);
    exit(0);
}

int isvoid(char c) {
    return c == 0 || isspace(c);
}

int cmp(const char *s1, const char *s2) {
    while (1) {
        while (isspace(*s1))
            ++s1;
        while (isspace(*s2))
            ++s2;
        while (1) {
            if (*s1 == 0 && *s2 == 0)
                return 0;
            if (isvoid(*s1) && isvoid(*s2))
                break;
            if (*s1 < *s2)
                return -1;
            if (*s1 > *s2)
                return +1;
            ++s1; ++s2;
        }
    }
}

typedef set<string> sset;

int n;
map<string, sset> e;

int t1;

int t2;
sset d;

char s[MAXLINE];
int u;

int main(int argc, const char *argv[]) {
    FILE *in = fopen(IN, "rt");
    if (!in)
        ERR("Viga sisendfaili %s avamisel", IN);
    if (fscanf(in, "%d ", &n) != 1)
        ERR("Viga sisendfaili lugemisel");
    for (int i = 0; i < n; ++i) {
        if (fgets(s, sizeof(s), in) != s)
            ERR("Viga sisendfaili lugemisel");
        istrstream ss(s);
        string s1, s2;
        ss >> s1; e[s1] = sset();
        while (ss >> s2)
            e[s1].insert(s2);
    }

    FILE *hint = fopen(HINT, "rt");
    if (!hint)
        ERR("Viga vihjefaili avamisel");
    if (fscanf(hint, "%d ", &t1) != 1)
        ERR("Viga vihjefaili lugemisel");

    FILE *out = fopen(OUT, "rt");
    if (!out)
        OK(0, "Viga väljundfaili %s avamisel", OUT);
    if (fgets(s, sizeof(s), out) != s)
        OK(0, "Enneaegne väljundfaili lõpp real 1");
    if (sscanf(s, "%d%n", &t2, &u) != 1 || cmp(s + u, "") != 0)
        OK(0, "Viga väljundfaili real 1");
    for (int i = 0; i < t2; ++i) {
        if (fgets(s, sizeof(s), out) != s)
            OK(0, "Enneaegne väljundfaili lõpp real %d", 2 + i);
        string x;
        for (istrstream ss(s); ss >> x; ) {
            if (e.find(x) == e.end())
                OK(0, "Tundmatu samm %s real %d", x.c_str(), 2 + i);
            for (sset::iterator j = e[x].begin(); j != e[x].end(); ++j)
                if (d.find(*j) == d.end())
                    OK(0, "Sammu %s eeldus %s täitmata real %d", x.c_str(), j->c_str(), 2 + i);
        }
        for (istrstream ss(s); ss >> x; ) {
            if (d.find(x) != d.end())
                OK(0, "Korduv samm %s real %d", x.c_str(), 2 + i);
            d.insert(x);
        }
    }
    for (map<string, sset>::iterator i = e.begin(); i != e.end(); ++i)
        if (d.find(i->first) == d.end())
            OK(0, "Samm %s tegemata", i->first.c_str());
    if (fscanf(out, "%10s", s) > 0)
        OK(0, "Liigsed andmed väljundfaili lõpus");

    if (t2 != t1)
        OK(0, "Vale aeg %d, peaks olema %d", t2, t1);
    OK(100, "OK");
}
