# -*- coding: utf-8 -*-

# 2011-12-17 programmeerimisvõistlus
# Ülesanne: VENNK
# Autor: Karl-Aksel Puulmann
# Testitud: Python 2.7.2, Python 3.2.2

from collections import deque

def main():
    def scanline(r, c, taide):
        if r < 0 or r >= korgus or c < 0 or c >= laius or diagramm[r][c] != '.':
            return #juba märgitud
        minx = maxx = c
        for x in range(c, -1, -1):
            if diagramm[r][x] != '.':
                break
            diagramm[r][x] = taide
            minx = x
        for x in range(c+1, laius):
            if diagramm[r][x] != '.':
                break
            diagramm[r][x] = taide
            maxx = x
        for x in range(minx, maxx+1):
            scanline(r+1, x, taide)
            scanline(r-1, x, taide)

    sisend = open('s3sis.txt')
    laius, korgus = [int(x) for x in sisend.readline().split()]
    diagramm = []
    for _ in range(korgus):
        diagramm.append(list(sisend.readline().strip()))

    ## Iga rea kohta vaatame ainult äärisest "välja jäävaid asju"
    ## Probleemi taustaga lahendame järgneval moodusel:
    ## alustada iga rea ja veeru algusest laiuti otsingut suvalise
    ## märgiga ja hiljem märgid tagasi asendada
    for r in range(korgus):
        scanline(r, 0, '+')
        scanline(r, laius-1, '+')
    for c in range(laius):
        scanline(0, c, '+')
        scanline(korgus-1, c, '+')
    mitmes = 0
    for r in range(korgus):
        for c in range(laius):
            if diagramm[r][c] == '.':
                scanline(r, c, chr(ord('A') + mitmes))
                mitmes += 1

    ## Taastame diagrammi,
    ## Teeme valjundi prinditavaks tekstiks ja väljastame faili
    valjund = '\n'.join(''.join(rida).replace('+','.') for rida in diagramm)
    open('s3val.txt','w').write(valjund)
    

main()
